//#pragma once
#ifndef CH_CHAN_C
#define CH_CHAN_C


#include <vector>   // the std vector
#include "drawareawidget.h" // just for Point_2 definition

CGAL_BEGIN_NAMESPACE


// entry point for Chan's alg. implementation
template <class ForwardIterator, class OutputIterator, class Traits> 
OutputIterator 
ch_chan( ForwardIterator first, 
		 ForwardIterator last, 
		 OutputIterator result, 
		 const Traits& ch_traits )
{

	if( first == last ) return result;             // nothing in the input (no points to process)
	typedef typename Traits::Point_2 Point_2;

	OutputIterator res( result );  // asi ukazuje na konec result

	// compute size of the input point set
	CGAL_ch_assertion_code( \
		long int count_points = 0 );
	CGAL_ch_assertion_code( \
		for( ForwardIterator fit = first; fit != last; ++fit ) ++count_points; )
	long int points_size = last -first;  // OK for vector, O(n) for list


	// find an extreme point to start gift wrapping		 
	ForwardIterator start;
	ch_w_point( first, last, start, ch_traits );

	// try to compute CH as   n/m groups of size m
	long int groupSize = 2;
	for( unsigned int t = 1; t < 6 ; t++ )  // should stop based on 2^2^t, t< 6 -- just for sure to stop if error in Chan's alg.
	{ 
	// ======== BEGIN OF SOLUTION - TASK 3-1 ======== //
	// ========  END OF SOLUTION - TASK 3-1  ======== //
	}

	return res;  //  used for t>=6 - safety stop
}

// ======== BEGIN OF SOLUTION - TASK 3-2 ======== //
// ========  END OF SOLUTION - TASK 3-2  ======== //

//Partition P into r = n/m disjoint subsets {p1, p2, , pr} of size at most m
//for i=1 to r do
//Convex hull by GrahamsScan(Pi), store vertices in ordered array
//let p1 = the bottom most point of P and p0 = (inf, p1.y)
//for k = 1 to m do     // compute merged hull points
//for i = 1 to r do  // angle to all r subsets     Compute the point qi elem P that maximizes the angle angle pk-1, pk, qi
//let pk+1 be the point q elem {q1, q2, , qr} that maximizes angle pk-1, pk, q
//if pk+1 = p1 then return {p1, p2, , pk} 
// return Fail, m was too small




CGAL_END_NAMESPACE

#endif // CH_CHAN_C
